"use strict";
exports.__esModule = true;
var jscodeshift = require("jscodeshift");
function createBuildFunction(fixer) {
    var foo = createMultipleEditBuildFunction(fixer);
    return function buildEditResponse(source, r, parser) {
        return foo(source, r, parser)[0];
    };
}
exports.createBuildFunction = createBuildFunction;
function createMultipleEditBuildFunction(fixer) {
    return function buildEditResponse(source, r, parser) {
        var api = jscodeshift.withParser(parser || 'babylon');
        var params = {
            j: api,
            ast: api(source),
            selection: r,
            logger: console
        };
        var action = fixer.suggestCodeAction(params);
        if (!action) {
            throw new Error('No suggested action returned from fixer');
        }
        var edit = fixer.createEdit({
            j: api,
            ast: api(source),
            data: action.data
        });
        if (!edit) {
            throw new Error('No edit returned from fixer');
        }
        var edits = edit instanceof Array ? edit : [edit];
        return edits.map(function (edit) { return ({
            title: action.title,
            newText: edit.newText,
            range: edit.range
        }); });
    };
}
exports.createMultipleEditBuildFunction = createMultipleEditBuildFunction;
